# coding: utf-8

"""
    Messente API

    [Messente](https://messente.com) is a global provider of messaging and user verification services.  * Send and receive SMS, Viber, WhatsApp and Telegram messages. * Manage contacts and groups. * Fetch detailed info about phone numbers. * Blacklist phone numbers to make sure you're not sending any unwanted messages.  Messente builds [tools](https://messente.com/documentation) to help organizations connect their services to people anywhere in the world.  # noqa: E501

    The version of the OpenAPI document: 1.4.0
    Contact: messente@messente.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from messente_api.configuration import Configuration


class ErrorItemStatistics(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'title': 'str',
        'details': 'str',
        'code': 'ErrorCodeStatistics'
    }

    attribute_map = {
        'title': 'title',
        'details': 'details',
        'code': 'code'
    }

    def __init__(self, title=None, details=None, code=None, local_vars_configuration=None):  # noqa: E501
        """ErrorItemStatistics - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._title = None
        self._details = None
        self._code = None
        self.discriminator = None

        self.title = title
        self.details = details
        self.code = code

    @property
    def title(self):
        """Gets the title of this ErrorItemStatistics.  # noqa: E501

        Error title  # noqa: E501

        :return: The title of this ErrorItemStatistics.  # noqa: E501
        :rtype: str
        """
        return self._title

    @title.setter
    def title(self, title):
        """Sets the title of this ErrorItemStatistics.

        Error title  # noqa: E501

        :param title: The title of this ErrorItemStatistics.  # noqa: E501
        :type: str
        """
        if self.local_vars_configuration.client_side_validation and title is None:  # noqa: E501
            raise ValueError("Invalid value for `title`, must not be `None`")  # noqa: E501

        self._title = title

    @property
    def details(self):
        """Gets the details of this ErrorItemStatistics.  # noqa: E501

        Error details  # noqa: E501

        :return: The details of this ErrorItemStatistics.  # noqa: E501
        :rtype: str
        """
        return self._details

    @details.setter
    def details(self, details):
        """Sets the details of this ErrorItemStatistics.

        Error details  # noqa: E501

        :param details: The details of this ErrorItemStatistics.  # noqa: E501
        :type: str
        """
        if self.local_vars_configuration.client_side_validation and details is None:  # noqa: E501
            raise ValueError("Invalid value for `details`, must not be `None`")  # noqa: E501

        self._details = details

    @property
    def code(self):
        """Gets the code of this ErrorItemStatistics.  # noqa: E501


        :return: The code of this ErrorItemStatistics.  # noqa: E501
        :rtype: ErrorCodeStatistics
        """
        return self._code

    @code.setter
    def code(self, code):
        """Sets the code of this ErrorItemStatistics.


        :param code: The code of this ErrorItemStatistics.  # noqa: E501
        :type: ErrorCodeStatistics
        """
        if self.local_vars_configuration.client_side_validation and code is None:  # noqa: E501
            raise ValueError("Invalid value for `code`, must not be `None`")  # noqa: E501

        self._code = code

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ErrorItemStatistics):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, ErrorItemStatistics):
            return True

        return self.to_dict() != other.to_dict()
